;;; Clisp NeXTStep MIDI foreign functions
;;; Leigh Smith leigh@cs.uwa.edu.au, leigh@psychokiller.dialix.oz.au
;;; 26/10/95

(in-package :cm)

(shadowing-import '(ffi:int ffi:slot ffi:element))

(use-package "FFI")

(def-c-call-in midi-input-hook
  (:name "MIDI_INPUT_HOOK")
  (:arguments (msg int) (time int))
  (:return-type nil))

;(defun midi-input-hook (event time)
;  (declare (special *midi-read-hook*) 
;           (optimize (speed 3) (safety 0)))
;  (when *midi-read-hook*
;    (funcall (the function *midi-read-hook*)
;	     (the fixnum event) (the fixnum time))))

;(defun %midi-open (port &aux num res flg)
;  (cond ((or (eql port nil) (eql port 0))
;         (setf num 0 res '(:A)))
;        ((eql port 1) (setf num 1 res '(:B)))
;        ((eql port t) (setf num 0 res '(:A :B))))
;  (if (= +midi-success+ (setf flg (%%midi-open num)))
;    res flg))

(def-c-call-out %%midi-open
  (:name "midiopen")
  (:arguments (port int))
  (:return-type int) )
(def-c-call-out %midi-close
  (:name "midiclose")
  (:return-type int) )
(def-c-call-out %midi-start-time
  (:name "midistarttimer")
  (:return-type int) )
(def-c-call-out %midi-stop-time
  (:name "midistoptimer")
  (:return-type int) )
(def-c-call-out %midi-get-time
  (:name "midigettime1")
  (:return-type int) )
;(def-c-call-out %midi-get-time
;  (:name "midigettime")
;  (:arguments (time (c-ptr (c-array int 2)) :in-out :alloca))
;  (:return-type int) )
;(def-c-call-out %midi-get-time1
;  (:name "midigettime1")
;  (:return-type int) )
(def-c-call-out %midi-set-time
  (:name "midisettime")
  (:arguments (time int))
  (:return-type int) )
(def-c-call-out %midi-read-messages
  (:name "midireadmessages")
  (:return-type int) )
(def-c-call-out %midi-write-message
  (:name "midiwritemessage")
  (:arguments (message int) (qtime int))
  (:return-type int) )
(def-c-call-out %midi-flush-transmit
  (:name "midiflushxmit")
  (:return-type int) )
(def-c-call-out %midi-flush-receive
  (:name "midiflushrecv")
  (:return-type int) )
(def-c-call-out %midi-hush
  (:name "midihush")
  (:return-type int) )
(def-c-call-out %midi-all-notes-off
  (:name "midiallnotesoff")
  (:arguments (time int))
  (:return-type int) )

